{# djlint:off H037 #}
<form
  {% if container %}
    action="{% url 'edit_container' identifier=application.identifier container_id=container.id %}"
    data-container-id="{{ container.id }}"
  {% else %}
    action="{% url 'create_container' identifier=application.identifier %}"
  {% endif %}
  data-app-id="{{ application.identifier }}"
  method="post">
  {# djlint:on H037 #}
  {% csrf_token %}

  {% if container %}
    <h5 class="mb-3">Edit container {{ container }}</h5>
  {% else %}
    <h5 class="mb-3">Create container for {{ application.descriptive_name }}</h5>
  {% endif %}

  <div class="mb-3 image-field">
    <label class="form-label d-flex flex-row justify-content-between">
      <div>Image (Required)</div>
      <div class="loading-message d-none">
        <div class="spinner-border spinner-border-sm text-primary" role="status">
          <span class="visually-hidden">Loading...</span>
        </div>
        Loading images from registry...
      </div>
    </label>
    <select class="form-select harbor-project-image" aria-label="Select an image for this container" data-app-id="{{ application.identifier }}" required>
      {% if container.image %}
        <option value="{{ container.image }}:{{ container.image_tag }}" selected>{{ container.image }}:{{ container.image_tag }}</option>
      {% else %}
        <option disabled selected>Select an image from image registry</option>
      {% endif %}
    </select>
    <div class="form-text">You need to have an image in your Harbor project at <a href="{{ harbor_url }}" target="_blank">{{ harbor_url }}</a> to select it here</div>
  </div>

  <div class="mb-3 d-none">
    <label class="form-label">Image (Required)</label>
    <input name="image" type="text" class="form-control container-image" {% if container.image %}value="{{ container.image }}"{% endif %} placeholder='e.g. repository/imagename' required>
  </div>

  <div class="mb-3 d-none">
    <label class="form-label">Image tag</label>
    <input name="image_tag" type="text" class="form-control container-image-tag" maxlength="50" {% if container.image_tag %}value="{{ container.image_tag }}"{% endif %} placeholder='e.g. latest (max 50 characters)'>
    <div class="form-text">Tag of the app image. Leaving this <strong>blank</strong> will set the tag to <strong>latest</strong></div>
  </div>

  <div class="mb-3">
    <label class="form-label">Exposed port</label>
    <input name="port" type="number" class="form-control container-port" {% if container.port %}value="{{ container.port }}"{% endif %} placeholder='e.g. 4444' min='0' max='65536'>
    <div class="form-text">Container port. If not provided, default to <strong>80</strong></div>
  </div>

    <!-- Make a container a main container -->
  <div class="mb-3">
        <!-- <label class="form-label">Main container</label> -->
    <div class="form-check">
      <input class="form-check-input" type="checkbox" name="is_main" {% if application.container_set.count == 0 or container.is_main %}checked{% endif %}>
      <label class="form-check-label">Set this container as the main container</label>
    </div>
    <div class="form-text">A main container has its port set as the application's port. This port is exposed to external traffic. Each app must have <strong>exactly 1 </strong> main container.</div>
  </div>

  <div class="mb-3">
    <label class="form-label">Runtime command</label>
    <div class="auto-suggest">
      <input name="command" class="form-control container-command" type='text' {% if container.command %}value="{{ container.command }}"{% endif %} placeholder="e.g. docker-compose exec web python3 manage.py makemigrations"></input>
      <span class="suggestions d-none"></span>
      <div class="mirror"></div>
    </div>
    <div class="form-text">Command to run when starting up the container. We provided interpolatable variables that are replaced after a successful deployment. To see the full list and to insert them into your command, simple press <strong>#</strong></div>
  </div>

  <div class="mb-5 environment-variables-display">
    <label class="form-label">Environment variables</label>
    <div class="environment-variables-holder">
      {% for key, value in container.get_environment_variables_without_quote.items %}
        <div class="row mb-1 environment-variable">
          <div class="col">
            <label class="mb-1 text-secondary fs-90percent">Key</label>
            <input class="form-control key" value="{{ key }}" placeholder="e.g. CLIENT_KEY" required>
          </div>
          <div class="col">
            <label class="mb-1 text-secondary fs-90percent">Value</label>
            <div class="auto-suggest">
              <input class="form-control value" value="{{ value }}" pattern='^[^"]*$' title="Please do not use double quotation marks in an environment variable value" required>
              <span class="suggestions d-none"></span>
              <div class="mirror"></div>
            </div>
          </div>
          <div class="col-1 d-flex flex-column justify-content-end">
            <i class="fa-solid fa-trash mt-auto mb-3 icon-btn-dark delete-btn"></i>
          </div>
        </div>
      {% endfor %}
    </div>
        <!-- <div class="icon-btn-dark cursor-default w-fit add-btn mt-1"><i class="fa-solid fa-plus"></i>Add another</div> -->
    <button type="button" class="btn btn-sm btn-dark mt-3 add-btn"><i class="fa-solid fa-plus me-2"></i>Add another</button>

        <!-- Import .env file -->
    <div class="mt-3">
      <label for="formFileSm" class="form-label text-secondary fs-90percent">Import a .env file</label>
      <input class="form-control form-control-sm w-fit env-file-input" type="file">
      <div class="form-text">Importing a .env file will add all environment variables listed in that file</div>
    </div>
  </div>

  <div class="mb-3 d-none">
    <label class="form-label">Environment variables</label>
    <textarea name="environment_variables" class='form-control container-environment-variables' maxlength="6990" type='text' rows='10' placeholder="SECRET_KEY=thisisasupersecretkey">{% if container.environment_variables %}{{ container.environment_variables }}{% endif %}</textarea>
    <div class="form-text">Environment variables for runtime</div>
  </div>

  <button type="submit" class="btn btn-primary">{% if container %}Submit{% else %}Create{% endif %}</button>
  {% if container %}
    <div class="btn btn-danger app-container-edit-form-cancel" data-container-id="{{ container.id }}">Cancel</div>
  {% else %}
    <div class="btn btn-danger app-container-create-form-cancel">Cancel</div>
  {% endif %}
</form>

